package betterwithmods.api.tile.multiblock;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;

public abstract class TileEntityMultiblock extends TileEntity implements IExternalCapability {
    private EnumFacing facing;
    private IMultiblock multiblock;
    private boolean isFormed;

    public IMultiblock getMultiblock() {
        return multiblock;
    }

    public void setMultiblock(IMultiblock multiblock) {
        this.multiblock = multiblock;
    }

    public void destroyMultiblock() {
        if (multiblock != null) {
            getMultiblock().destroyMultiblock(field_145850_b, field_174879_c, getFacing());
        }
    }

    public boolean isFormed() {
        return isFormed;
    }

    public void setFormed(boolean formed) {
        isFormed = formed;
    }

    public EnumFacing getFacing() {
        return facing;
    }

    public void setFacing(EnumFacing facing) {
        this.facing = facing;
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound compound = super.func_189515_b(tag);
        compound.func_74778_a("facing", facing.func_176610_l());
        return compound;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        facing = EnumFacing.UP;
        if (tag.func_74764_b("facing")) facing = EnumFacing.func_176739_a(tag.func_74779_i("facing"));
        super.func_145839_a(tag);
    }

    @Override
    public SPacketUpdateTileEntity func_189518_D_() {
        return new SPacketUpdateTileEntity(this.field_174879_c, 3, this.func_189515_b(new NBTTagCompound()));
    }

    @Override
    public void onDataPacket(NetworkManager man, SPacketUpdateTileEntity pkt) {
        this.func_145839_a(pkt.func_148857_g());
    }
}
